//------------------------------------------------------------------
#property copyright "www.forex-tsd.com" 
#property link      "www.forex-tsd.com" 
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  DarkGray
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum -1.1
#property indicator_maximum +1.1

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    EmaFast         = 5;
extern int    EmaSlow         = 12;
extern int    EmaPrice        = PRICE_CLOSE;
extern int    RsiPeriod       = 14;
extern int    RsiPrice        = PRICE_CLOSE;
extern int    MaMode          = MODE_EMA;
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsNotify    = true;
extern bool   alertsEmail     = true;

double signup[];
double signdn[];
double trend[];
int timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,signup); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,signdn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,trend);
      timeFrame = stringToTimeFrame(TimeFrame);
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for(int i = limit; i >= 0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
      double macd = iMA(NULL,timeFrame,EmaFast,0,MaMode,EmaPrice,y)-iMA(NULL,timeFrame,EmaSlow,0,MaMode,EmaPrice,y);
      double rsi  = iRSI(NULL,timeFrame,RsiPeriod,RsiPrice,y);
         signup[i] = EMPTY_VALUE;
         signdn[i] = EMPTY_VALUE;
         trend[i]  = trend[i+1];
            if (macd > 0 && rsi > 50) { trend[i]=  1; signup[i] =  1; }
            if (macd < 0 && rsi < 50) { trend[i]= -1; signdn[i] = -1; }
   }
   
   //
   //
   //
   //
   //
   
   if (alertsOn)
    {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      
      //
      //
      //
      //
      //
      
      if (signup[whichBar+1] == EMPTY_VALUE && signup[whichBar] != EMPTY_VALUE) doAlert(whichBar,"buy signal");
      if (signdn[whichBar+1] == EMPTY_VALUE && signdn[whichBar] != EMPTY_VALUE) doAlert(whichBar,"sell signal");
    }         
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

int stringToTimeFrame(string tfs)
{
   StringToUpper(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," ema + rsi binary ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " ema + rsi binary "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}


